var market_packagename = "com.farsitel.bazaar";
var market_bind = "ir.cafebazaar.pardakht.InAppBillingService.BIND";
var provider_name = 'کافه بازار';
if(iap_provider == 'myket')
{
	market_packagename = "ir.mservices.market";
	market_bind = "ir.mservices.market.InAppBillingService.BIND";
	provider_name = 'مایکت';
}

angular.module('ngApp').controller('iapCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading) {
	$scope.pay = function(productId, type, sl) {
		if (isDevice) {
			if (isOnline()) {
				$ionicLoading.show();
				inappbilling.init(function() {
					//success init
					inappbilling[type](function(result) {
						// success buy
						$scope.verify(result, type, sl);
					}, function() {
						showError('خطا در فرایند خرید');
					} ,productId);
				}, function() {
					//error init
					showWarning('<h4> خطا در اتصال</h4> برای پرداخت باید به حساب ' + provider_name + ' خود وارد شوید');
					setTimeout(function () {
						if (iap_provider == 'cafebazaar') {
							window.open('bazaar://login', '_system');
						} else {
							window.open('myket://details', '_system');
						}
					}, 3000);
				}, {showLog:false}, market_packagename, market_bind, iap_RSA_key);
			} else {
				checkYourInternet();
			}
		} else {
			showWarning('این امکان فقط در فایل خروجی امکان پذیر است');
		}
	};

	$scope.payByCode = function(productId, code, sl)
	{
		var data = {
			productId : productId,
			code : code
		};

		$scope.verify(data, 'code', sl);
	}

	$scope.verify = function(result, type, sl) {
		$ionicLoading.show();

		if(iap_pay_secure)
		{
			$.ajax({
				type      : 'POST',
				url       : url + '/api/v1/widget/post/cafebazaar-iap/postCafeCheckPeyment?sl=' + sl,
				data      : {
								packageName : result.packageName,
								productId : result.productId,
								purchaseToken : result.purchaseToken,
								provider : iap_provider,
								code : result.code,
								type : type,
							},
				dataType  : 'json',
				encode    : true
			})
			.done(function(data) {
				$ionicLoading.hide();
				if(typeof data.result != 'undefined' && data.result == 'success'){
					$scope.successBuy(result);
				}else{
					showError(data.error);
				}
			})
			.fail(function(data) {
				$ionicLoading.hide();
				$ionicPopup.alert({
					cssClass: 'iap_pupop',
					title: '',
					template: 'خطا در تایید خرید. اتصال اینترنت خود را بررسی کند و مجددا تلاش کنید.',
					buttons: [
					 {
						text: '<b>تلاش مجدد</b>',
						type: 'button-positive',
						onTap: function(e) {
						  $scope.verify(result, type, sl);
						}
					 },
					 {
						text: 'بستن',
						type: 'button-stable'
					 }
					]
				});
			});
		}else{
			$scope.successBuy(result);
		}
	};

	$scope.successBuy = function(result) {

		$rootScope[result.productId] = true;

		if(removeAdArray[result.productId]){
			var removeAd = new Event('removeAd');
			document.dispatchEvent(removeAd);
		}

		$ionicPopup.show({
			cssClass: 'iap_pupop',
			title: 'خرید موفق',
			template: success_massages[result.productId],
			buttons: [{
			  text: 'بستن',
			  type: 'button-clear button-balanced'
			}],
		});

		if(iap_provider == 'code'){
			saveCodeLocalStorage(result);
		}else{
			updateLocalStorage();
		}

		$ionicLoading.hide();
		window.location.hash = homeHash;
	}
})

document.addEventListener("deviceready", function(){

	// for saved local data in old Versions
	if(window.localStorage['ownedProducts']){
		NativeStorage.set('ownedProducts', window.localStorage['ownedProducts'],
			function (result) {
				localStorage.removeItem('ownedProducts');
			},
			function (e) {
			});
	}

	NativeStorage.getString('ownedProducts',
		function (result) {
			if( !(result == 'null' || result == null) ) {
				unlockPages(angular.fromJson(result));
			}
		},
		function (e) {

		});

	if(iap_provider != 'code'){
		setTimeout(function() {
			inappbilling.init(function(){
				//success init
				updateLocalStorage();
			}, function(){
				//error init
			}, {showLog:false}, market_packagename, market_bind, iap_RSA_key);
		}, 100);
	}
});

function unlockPages(purchasesItem) {
	var $body = angular.element(document.body);
	var $rootScope = $body.injector().get('$rootScope');

	for (var i = 0; i < purchasesItem.length; i++) {
		$rootScope[purchasesItem[i].productId] = true;
	}

	$rootScope.$apply();
	$rootScope.updateAdStatus();
}

function updateLocalStorage() {
	inappbilling.refreshPurchases(function(purchasesItem) {

		for (var i = 0; i < purchasesItem.length; i++) {
			purchasesItem[i].receipt = '';
			purchasesItem[i].signature = '';
		}

		var json = angular.toJson(purchasesItem);

		//update localStorage if change
		NativeStorage.getString('ownedProducts',
			function (result) {
				if(json != result){
					unlockPages(purchasesItem);
					saveOwnedProducts(json);
				}
			},
			function (e) {

			});

	}, function() {	});
}


function saveCodeLocalStorage(item) {
	if (isDevice) {
		NativeStorage.getString('ownedProducts',
			function (result) {
				result = (result == 'null' || result == null) ? '[]' : result;
				ownedProducts = angular.fromJson(result);
				ownedProducts.push(item);
				var json = angular.toJson(ownedProducts);
				saveOwnedProducts(json);
			},
			function (e) {
				ownedProducts = [];
				ownedProducts.push(item);
				var json = angular.toJson(ownedProducts);
				saveOwnedProducts(json);
			});
	} else {
		// webapp
		var local = window.localStorage['ownedProducts'];
		local = typeof local == 'undefined' ? [] : local;
		var ownedProducts = angular.fromJson(local);
		ownedProducts.push(item);
		unlockPages(ownedProducts);
		window.localStorage['ownedProducts'] = angular.toJson(ownedProducts);
	}
}


function saveOwnedProducts(data) {
	NativeStorage.set('ownedProducts', data,
	   function (result) {
		   console.log("Saved Data : " + result);
	   },
	   function (e) {
		   console.error("Write Object Failed");
	});
}

function IapPlatformReady() {
	// web app config raedy
	if (!isDevice) {
		var local = window.localStorage['ownedProducts'];
		if (typeof local != 'undefined')
			unlockPages(angular.fromJson(local));
	}
}