function successPayEcommerce() {
	showSuccess(lang('video-commerce.payment_success'));
	window.location.hash = homeHash;
}

function errorPayEcommerce() {
	showError(lang('video-commerce.your_payment_was_not_successful'));
	window.location.hash = homeHash;
}

angular
    .module('ngApp')
    .controller('videoCommerceCtrl', function(
        $scope, 
        $http, 
        $ionicScrollDelegate, 
        $location, 
        localStorage,
        $stateParams,
        $rootScope,
        $ionicLoading,
        $ionicPopup
    ) {
        /**
         * NOTE: CURRENTLY NOT USED
         * ISSUE: #83
         * 
         * This function responsible to save current status of more items
         * to the local storage, it is neccessary for us to know what is 
         * the previous status of moreItems when going back to the previous
         * page.
         */
        $scope.resolveMoreItems = function (currentLocation) {
            if (currentLocation.indexOf('/video/') !== -1) {
                return;
            }
            var storageKey = $scope.initData.hash + '|moreItems|' + currentLocation;
            var oldValue = localStorage.all(storageKey);
            if (angular.equals(oldValue, {}) && $scope.moreItems != false) {
                $scope.moreItems = true;
                localStorage.save($scope.moreItems, storageKey);
            } else {
                localStorage.save($scope.moreItems, storageKey);
            }
        }

        /**
         * NOTE: CURRENTLY NOT USED
         * ISSUE: #83
         * 
         * This function responsible to save current status of next page
         * to the local storage, it is neccessary for us to know what is 
         * the previous status of nextPage when going back to the previous
         * page.
         */
        $scope.resolveNextPage = function (currentLocation) {
            if (currentLocation.indexOf('/video/') !== -1) {
                return;
            }
            var storageKey = $scope.initData.hash + '|nextPage|' + currentLocation;
            var oldValue = localStorage.all(storageKey);
            if (angular.equals(oldValue, {}) && $scope.nextPage != 0) {
                $scope.nextPage = 0;
                localStorage.save($scope.nextPage, storageKey);
            } else {
                localStorage.save($scope.nextPage, storageKey);
            }
        }

        $scope.refreshPaginationData = function () {
            $scope.moreItems = true;
            $scope.nextPage = 0;
            $scope.refresh = true;
        }

        // Init basic data in first loading
        $scope.landing = [];
        $scope.videos = [];
        $scope.video = localStorage.all('current-video');
        $scope.refreshPaginationData();

        // Lets fresh the init data when route was changed to avoid data cinflict
        $scope.$on('$locationChangeStart', function($event, next, current) { 
            // console.log('route changed!');
            // $scope.refreshPaginationData(); <-------  Old code --------------------------|
            // $scope.resolveNextPage(current);  -|                                         |---> But every thing is ok when this codes was commented
            //                                    |----> New solution to resolve issue #83 -|
            // $scope.resolveMoreItems(current); -|
        });

        $scope.onIndexPageInit = function (initData) {
            // console.log('onIndexPageInit');
            $scope.initData = initData;
            $scope.loadMainPageContents(false);
        }

        $scope.onVideoPageInit = function (initData) {
            // console.log('onVideoPageInit');
            $scope.initData = initData;
        }

        $scope.onVideosPageInit = function (initData) {
            // console.log('onVideosPageInit');
            $scope.initData = initData;
            $scope.categories = localStorage.all('current-categories');
            $scope.slider = localStorage.all('current-slider');
            var loop = $scope.slider.effect == 'cube' ? false : true;
            $scope.slideroptions = {
                loop: loop,
                speed: 400,
                //autoHeight: true,
                autoplay: $scope.slider.duration * 1000,
                effect: $scope.slider.effect
            };
            $scope.loadVideos(false);
        }

        $scope.doRefresh = function (action) {
            $scope.refreshPaginationData();
            $scope.videos = [];
            $scope.refresh = true;

            switch (action) {
                case 'loadMainPageContents':
                    $scope.loadMainPageContents(true);       
                    break;
                case 'loadVideos':
                    $scope.loadVideos(true);       
                    break;
                case 'loadVideo':
                    $scope.loadVideo(true);       
                    break;
                default:
                    break;
            }
        }

        $scope.loadMore = function (action) {
            // console.log('load more!');
            if (!$scope.moreItems) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            $scope.nextPage++;
            switch (action) {
                case 'loadVideos':
                    $scope.loadVideos(false);       
                    break;
                default:
                    break;
            }
        }

        $scope.loadVideo = function (refresh) {
            // Load videos
            if (isOnline()) {
                if (!refresh) {
                    $scope.loading = true;
                }
                $http({
                        method: 'GET',
                        noLoading: true,
                        url: 
                            $scope.initData.get_video_url + '/' + 
                            $scope.initData.sl + '?' +
                            'code=' + $scope.video.code
                    })
                    .success(function (data) {
                        if (data.success) {
                            $scope.video = data.video;
                            localStorage.save(data.video, 'current-video');
                        } else {
                            $scope.storage = lang('video-commerce.fail_to_load');
                        }
                        $scope.loading = false;
                        $scope.refresh = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function () {
                        $scope.storage = lang('video-commerce.fail_to_load');
                        $scope.loading = false;
                        $scope.refresh = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                    });
            } else {
                $scope.loading = false;
                $scope.refresh = false;
                checkYourInternet();
            }
        }

        $scope.loadVideos = function (refresh) {
            var cat_id_query = $stateParams.cat_id === undefined ? 'null=null' : 'cat_id=' + $stateParams.cat_id;
            // Load videos
            if (isOnline()) {
                if (!refresh) {
                    $scope.loading = true;
                }
                $http({
                        method: 'GET',
                        noLoading: true,
                        url: 
                            $scope.initData.get_videos_list_url + '/' + 
                            $scope.initData.sl + '?' + 
                            cat_id_query + '&' + 
                            'request_type=json&' +
                            'page=' + $scope.nextPage
                    })
                    .success(function (data) {
                        if (data.videos) {
                            for (var i = 0 ; i < data.videos.length ; i++)
						    {
							    $scope.videos.push(data.videos[i]);
						    }
                            if (data.videos.length < 6) {
                                $scope.moreItems = false;
                            } else {
                                $scope.moreItems = true;
                            }
                        } else {
                            $scope.storage = lang('video-commerce.fail_to_load');
                        }
                        $scope.loading = false;
                        $scope.refresh = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function () {
                        $scope.storage = lang('video-commerce.fail_to_load');
                        $scope.loading = false;
                        $scope.refresh = false;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.$broadcast('scroll.refreshComplete');
                    });
            } else {
                $scope.loading = false;
                $scope.refresh = false;
                checkYourInternet();
            }

        }

        $scope.handleVideoClick = function (item) {
            // console.log('hi click', item);
            localStorage.save(item, 'current-video');
            $scope.loadVideo(false);
            $location.path(item.link);
        }

        $scope.handlePurchasedVideosClick = function () {
            // /nav/video-commerce869/purchasedVideos
            $location.path('/nav/' + $scope.initData.slug + '/purchasedVideos');
        }

        $scope.handleVideoPlay = function (item) {
            // console.log('hey play me', item);
            $scope.playVideo(item.video);
        }

        $scope.handleTeaserVideoPlay = function (item) {
            // console.log('hey play me', item);
            $scope.playVideo(item.teaser);
        }

        $scope.handleDownloadVideo = function (item) {
            var currentVideo = localStorage.all('current-video');
            var videoId = currentVideo.code.split('|')[1];
            // console.log('hey! download me!', item, videoId);

            if (isOnline()) {
                $http({
                        method: 'GET',
                        noLoading: true,
                        url: 
                            $scope.initData.get_video_download_url + '/' + 
                            $scope.initData.sl + '?' + 
                            'video_id=' + videoId + '&' +
                            'link_to_download=' + item.video
                    })
                    .success(function (data) {
                        // console.log(data);
                        if (data.success) {
                            var target = ionic.Platform.isAndroid() ? '_system' : '_blank';
                            window.open(data.url, target);
                        } else {
                            $scope.storage = lang('video-commerce.fail_to_download');
                        }
                        $scope.loading = false;
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function () {
                        $scope.storage = lang('video-commerce.fail_to_download');
                        $scope.loading = false;
                        $scope.$broadcast('scroll.refreshComplete');
                    });
            } else {
                $scope.loading = false;
                checkYourInternet();
            }
        }

        $scope.playVideo = function (videoUrl) {
            var options = {
                successCallback: function() {

                },
                errorCallback: function(errMsg) {

                },
                orientation: 'landscape',
                shouldAutoClose: true,
                controls: true
            };

            if(!isDevice) {
                showWarning(lang('video-commerce.not_available_in_similator'));
                return;
            }
            
            // console.log(videoUrl);
            window.plugins.streamingMedia.playVideo(videoUrl, options);
        }

        $scope.handlePayButton = function (item) {
            // console.log('hello pay', item, $scope.initData);
            if (!$rootScope.isUserLoggedIn()) {
                $rootScope.forceToLoggedIn();
                return;
            }

            if (isOnline()) {
                $http({
                    method: 'POST',
                    noLoading: false,
                    url: url + '/api/v1/widget/post/video-commerce/postCheckout?sl=' + $scope.initData.sl + '&request_type=json',
                    data: {
                        videoId: item.code.split("|")[1]
                    }
                })
                .success(function (data) {
                    // console.log(data);
                    if (typeof data === 'undefined') {
                        return;
                    }
                    var provider = data.provider;
                    if (provider === 'zarinpal') {
                        var target = ionic.Platform.isAndroid() ? '_system' : '_blank';
                        window.open(data.paymenturl, target);
                        ionic.Platform.exitApp();
                        window.close();
                    } else if (provider === 'cafebazaar') {
                        if(!isDevice) {
                            showWarning(lang('video-commerce.not_available_in_similator'));
                            return {
                                data: {
                                    success: false,
                                    error: 'This feature is only available in application',
                                    payload: {
                                        provider: 'cafebazaar',
                                    },
                                },
                            };
                        }
                        var type = 'buy';
                        var appUserDataId = data.appUserDataId;
                        $ionicLoading.show();
                        try {
                            inappbilling.init(
                                function() {
                                    inappbilling[type](
                                        function(result) {
                                            $scope.verifyInappPlanPayment(result, type, appUserDataId);
                                        }, function() {
                                            showError(lang('video-commerce.payment_failed'));
                                            return;
                                        },
                                        $scope.video.cafebazaar.product_id
                                    );
                                }, 
                                function() {
                                    showWarning(
                                        lang('video-commerce.fail_iap_message1') +
                                        $scope.initData.payment_provider +
                                        lang('video-commerce.fail_iap_message2')
                                    );
                                    setTimeout(function () {
                                            window.open('bazaar://login', '_system');
                                    }, 3000);
                                },
                                { 
                                    showLog: false 
                                },
                                'com.farsitel.bazaar',
                                'ir.cafebazaar.pardakht.InAppBillingService.BIND',
                                $scope.initData.cafebazaar.RSAKey
                            );   
                        } catch (error) {
                            $scope.loading = false;
                            $ionicLoading.hide();
                            $scope.$broadcast('scroll.refreshComplete');
                            showWarning(
                                lang('video-commerce.fail_iap_confirm') +
                                $scope.initData.payment_provider
                            );
                        }
                    }

                    $scope.$broadcast('scroll.refreshComplete');
                })
                .error(function () {
                    $scope.storage = lang('video-commerce.payment_failed');
                    $scope.loading = false;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            } else {
                $scope.loading = false;
                checkYourInternet();
            }
        }

        $scope.planInappPaymentSucceeded = function(result, appUserDataId) {
            $http({
                method: 'POST',
                url: url + '/api/v1/widget/post/video-commerce/cafebazaarPlanPaymentSuceeded',
                params: {
                    sl: $scope.initData.sl,
                    appUserDataId: appUserDataId
                }
            })
            .success(function (response) {
                if (response.success) {
                    $ionicLoading.hide();
                    $scope.video.is_purchased = true;
                    $ionicPopup.show({
                        cssClass: 'iap_pupop',
                        title: lang('video-commerce.payment_successed'),
                        buttons: [{
                          text: lang('global.close'),
                          type: 'button-clear button-balanced'
                        }],
                    });
                    window.location.hash = homeHash;
                } else {
                    $ionicLoading.hide();
                    $ionicPopup.show({
                        cssClass: 'iap_pupop',
                        title: lang('video-commerce.the_purchase_failed'),
                        buttons: [{
                          text: lang('global.close'),
                          type: 'button-clear button-balanced'
                        }],
                    });
                }
            }).error(function (error) {
                $ionicLoading.hide();
                $ionicPopup.show({
                    cssClass: 'iap_pupop',
                    title: lang('video-commerce.the_purchase_failed'),
                    buttons: [{
                      text: lang('global.close'),
                      type: 'button-clear button-balanced'
                    }],
                });
            });
        }

        $scope.verifyInappPlanPayment = function(result, type, appUserDataId) {
            $ionicLoading.show();
            $http({
                method: 'POST',
                url: url + '/api/v1/widget/post/video-commerce/cafebazaarVerifyPlanPayment?sl=' + $scope.initData.sl,
                data: {
                    packageName: result.packageName,
                    productId: result.productId,
                    purchaseToken: result.purchaseToken,
                    provider: 'cafebazaar',
                    code: result.code,
                    type: type,
                },
                responseType: 'json'
            })
            .success(function(data) {
                $ionicLoading.hide();
                data.success === true ?
                    $scope.planInappPaymentSucceeded(result, appUserDataId) :
                    showError(data.error);
            }).error(function() {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    cssClass: 'iap_pupop',
                    title: '',
                    template: lang('video-commerce.fail_iap_confirm2'),
                    buttons: [{
                        text: '<b>' + lang('video-commerce.try_again') + '</b>',
                        type: 'button-positive',
                        onTap: function() {
                            $scope.verifyInappPlanPayment(result, type);
                        }
                    }, {
                        text: lang('global.close'),
                        type: 'button-stable'
                    }]
                });
            });
        };

        $scope.loadMainPageContents = function (refresh) {
            // Load
            if (isOnline()) {
                if (!refresh) {
                    $scope.loading = true;
                }
                $http({
                        method: 'GET',
                        noLoading: true,
                        url: url + '/api/v1/widget/route/video-commerce/getVideosAndLanding/' + $scope.initData.sl
                    })
                    .success(function (data) {
                        if (data.landing) {
                            $scope.landing = data.landing;
                            localStorage.save(data.landing.categories, 'current-categories');
                            localStorage.save(data.landing.slider, 'current-slider');
                            var loop = $scope.landing.slider.effect == 'cube' ? false : true;
                            $scope.slideroptions = {
                                loop: loop,
                                speed: 400,
                                //autoHeight: true,
                                autoplay: $scope.landing.slider.duration * 1000,
                                effect: $scope.landing.slider.effect
                            };

                            if (data.landing.categories_count <= 1) {
                                $scope.loadVideos(false);
                            }

                            setTimeout(function () {
                                $ionicScrollDelegate.scrollTo(2000, 0, false);
                            }, 100);
                        } else {
                            $scope.storage = lang('video-commerce.fail_to_load');
                        }
                        $scope.loading = false;
                        $scope.$broadcast('scroll.refreshComplete');
                    })
                    .error(function () {
                        $scope.storage = lang('video-commerce.fail_to_load');
                        $scope.loading = false;
                        $scope.$broadcast('scroll.refreshComplete');
                    });
            } else {
                $scope.loading = false;
                checkYourInternet();
            }

        }
    });

/*fix horizontal Scroller*/
(function () {
    var t = function () {
        return function (t, e) {
            return {
                restrict: "A",
                link: function (o, n, r) {
                    var a = r.horizontalScrollFix,
                        i = r.delegateHandle,
                        c = function (t) {
                            return t.touches && (t.touches.length ? t.touches : [{
                                pageX: t.pageX,
                                pageY: t.pageY
                            }])
                        },
                        l = function () {
                            var o, n;
                            o = e.$getByHandle(a).getScrollView(), (n = e.$getByHandle(i).getScrollView()).__container.removeEventListener("touchstart", n.touchStart), n.touchStart = function (e) {
                                var r;
                                n.startCoordinates = ionic.tap.pointerCoord(e), ionic.tap.ignoreScrollStart(e) || (n.__isDown = !0, ionic.tap.containsOrIsTextInput(e.target) || "SELECT" === e.target.tagName ? n.__hasStarted = !1 : (n.__isSelectable = !0, n.__enableScrollY = !0, n.__hasStarted = !0, n.doTouchStart(c(e), e.timeStamp), r = o.__scrollTop, t(function () {
                                    var t, e;
                                    return e = r - o.__scrollTop, n.__isDragging && e < 2 && e > -2 ? (o.__isTracking = !1, o.doTouchEnd(), t = !1, o.scrollTo(0, r, t)) : n.doTouchEnd()
                                }, 100)))
                            }, n.__container.addEventListener("touchstart", n.touchStart)
                        };
                    t(function () {
                        l()
                    })
                }
            }
        }
    }();
    angular.module("ngApp").directive("horizontalScrollFix", ["$timeout", "$ionicScrollDelegate", t])
}).call(this);